(function () {

var
	cfg = widget.preferences,
	oex = opera.extension,
	img = document.querySelector('html:root>body img[src=""]'),
	isRaster = document && (img || {src: null}).src === window.location.href;

if (isRaster/* || (document instanceof window.SVGDocument && document.URL === window.top.location.href)*/) {
	// localStorage is too slow
	var prefs = {dam: parseInt(widget.preferences.dam, 10)};
	if (prefs.dam === 4) { return; }

	img.naturalWidth = 0;
	img.error = true;

	if (prefs.dam === 5) {
		img.onclick = window.onkeypress = window.onmousedown = window.onmouseup = window.onmousemove = null;
		return;
	}

	//if (isRaster) {
		img = new Image();

		document.head.innerHTML = '<style>html{height:100%}body{width:100%;height:100%;margin:0;font:12px Verdana,"DejaVu Sans"}h2{padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff}.m_1{max-width:100%;max-height:100%;width:auto;height:auto}.m_2{width:100%;height:auto}.m_3{height:100%;width:auto}</style>';

		img.onerror = function() {
			img = {error: true};
			document.body.innerHTML = '<h2>' + LNG.IMG_FAILED + '</h2>';
		};

		// clone to skip incompatibilities
		img.src = document.images[0].src;
		img.alt = (img.src.indexOf('data:') === 0 ? 'Image (inline)' : window.location.pathname.replace(/.*\//, '') || 'Image');

		document.body.innerHTML = '<h2>' + img.alt + '</h2>';
		document.body.firstElementChild.onclick = function () {this.parentNode.appendChild(img); this.parentNode.removeChild(this);};		
	/*}
	else {
		return;
		var img = '';
	}*/

	oex.onmessage = function () {
		if (img.error) {
			return;
		}

		// preferences
		var prefs = {
			dam: parseInt(cfg.dam, 10),
			pos: cfg.pos,
			backg: cfg.backg || 0,
			imgBg: cfg.imgbg || 0,
			imgBorder: cfg.imgborder || 0,
			hideSB: parseInt(cfg.hidesb, 10),
			mDownDelay: parseInt(cfg.mdowndelay, 10),
			pixelmove: parseInt(cfg.pixelmove, 10),
			dragScroll: 1.15 //parseInt(cfg.dragscroll, 10) ? Math.max(Math.min(cfg.dragscroll, 2), 1.05) : 0,
			//transDur: parseInt(cfg.transdur, 10)
		},
		keys = JSON.parse(cfg.keys || '{}'),

		sX, sY,
		noFit = {cur: false, real: false},
		progress = null,
		cancelAction = false,
		fZoom = null,
		pixelThresHold = prefs.pixelmove,
		dragScroll = [],
		borderSize,
		MAXSIZE = 0x7fff,
		init = {loop: 0, wait: 200, maxLoop: 1500};

		function setStatus(force) {
			if (!(img.naturalWidth && img.naturalHeight)) { return; }
			window.status = img.width + 'x' + img.height +' (' + (Math.round(1E4 * (img.width / img.naturalWidth)) / 100) + '% of ' + img.naturalWidth + 'x' + img.naturalHeight + ')';
		}

		//setTimeout(function () {document.head.innerHTML += '<link rel="shortcut icon" href="http://www.google.com/s2/favicons?domain=' +  window.location.host + '">';}, 0);

		var nodeStyle = '';

		// scrollbars
		if (prefs.hideSB) {
			nodeStyle += 'overflow:hidden;';
		}

		// background color
		if (prefs.backg) {
			/*if (/^(?:http|-o-skin)/i.test(prefs.backg)) { document.documentElement.style.backgroundImage = prefs.backg; }
			else { document.documentElement.style.backgroundColor = prefs.backg; }*/
			nodeStyle += 'background:' + prefs.backg;
		}

		if (nodeStyle !== '') {
			document.documentElement.style.cssText = nodeStyle;
		}

		nodeStyle = 'position:absolute;';

		// image background
		if (prefs.imgBg) {
			if (prefs.imgBg === 'CheckerBoard') {
				nodeStyle += 'background-image:url("data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7");';
			}
			else if (/^(?:http|-o-skin)/i.test(prefs.imgBg)) { nodeStyle += 'background-image:' + prefs.imgBg + ';'; }
			else { nodeStyle += 'background-color:' + prefs.imgBg + ';'; }
		}

		if (prefs.imgBorder) {
			nodeStyle += 'border:' +prefs.imgBorder + ';';
			borderSize = parseInt(img.style.borderWidth, 10);

			if (!prefs.imgBorder.match(/!\s*important\s*$/) && borderSize > 100) {
				borderSize = 100;
				nodeStyle += 'border-width:' + borderSize + ';';
			}

			nodeStyle += 'background-origin:padding-box;background-clip:padding-box;box-sizing:border-box;';
		}
		else { borderSize = 0; }

		img.style.cssText = nodeStyle;

		// image resizer
		img.resize = function(m, w, h) {
			if (m === 4) {
				prefs.dam = 4;
				this.style.display = 'none';
				this.parentNode.style.backgroundImage = 'url("'+this.src+'")';

				return;
			}
			else if (prefs.dam === 4) {
				this.style.display = 'run-in';
				this.parentNode.style.backgroundImage = '';
			}
			else if ((m === -1 && fZoom) || m === -1) {
				this.style.width = (w === '' ? w : w + 'px');
				h && (this.style.height = (h === '' ? h : h + 'px'));

				if ((w === '' || w === this.naturalWidth) && (h === '' || h === this.naturalHeight)) {
					m = 0;
				}
			}

			if (m !== -1 && prefs.dam === -1) {
				this.style.width = this.style.height = '';
			}

			this.className !== 'm_' + m && (this.className = 'm_' + m);

			if (this.naturalWidth && this.naturalHeight && this.calcFit) {
				this.position(prefs.pos);
				this.calcFit();
				this.hScroll();
				this.cursor();
				setStatus();
			}

			prefs.dam = m;
		};

		function load(noneedinterval) {
			if (img.error) {
				if (progress) { clearInterval(progress); }
				return;
			}

			if (img.width > 0 || noneedinterval) {
				clearInterval(progress);
				progress = null;

				if (img.naturalWidth === undefined || img.naturalHeight === undefined) {
					img.naturalWidth = img.width;
					img.naturalHeight = img.height;
				}

				document.body.innerHTML = '';
				document.body.appendChild(img);

				// Opera does not support images larger than ??MP
				/*if (img.naturalWidth * img.naturalHeight > 100 * 10E6) {
					document.body.innerHTML = '<h2>' + LNG.IMG_TOO_LARGE + '</h2>';
					return;
				}*/

				// Opera bug? - Clicking on image after 2^14 - 2 pixels in width, won't handle as image
				//if (img.naturalWidth > 16382) {
					//
				//}

				var hLayer, createHelper = function () {
					if (hLayer) { return; }
					hLayer = document.createElement('DIV');
					hLayer.style.cssText = 'position:fixed;display:none;z-index:665;left:0px;top:0px;width:100%;height:100%;box-sizing:border-box;background-clip:padding-box;white-space:nowrap;color:#fff;text-shadow:1px 1px 1px #000;overflow:hidden';

					hLayer.hide = function(e) {
						if (cancelAction || (e && e.shiftKey)) { return; }

						hLayer.style.display = 'none';
					};

					document.body.appendChild(hLayer);
				};

				img.position = function(p) {
					if (p.length === 2) {
						var bgM = (prefs.dam === 4), bgPos = '';

						var r = this.currentdeg && Math.sin(this.currentdeg) ? true : false;

						switch (p.charAt(1)) {
							case '0' : if (bgM) { bgPos = 'top '; } else { this.style.top = '0px'; } break;
							case '2' : if (bgM) { bgPos = 'bottom '; } else { this.style.top = Math.max(0, document.body.clientHeight - (r ? this.width : this.height) - borderSize * 2) + 'px'; } break;
							default: if (bgM) { bgPos = 'center '; } else { this.style.top = Math.max(0, (document.body.clientHeight - (r ? this.width : this.height)) / 2 - borderSize) + 'px'; }
						}

						switch (p.charAt(0)) {
							case '0' : if (bgM) { bgPos += 'left'; } else { this.style.left = '0px'; } break;
							case '2' : if (bgM) { bgPos += 'right'; } else { this.style.left = Math.max(0, document.body.clientWidth - (r ? this.height : this.width) - borderSize * 2) + 'px'; } break;
							default : if (bgM) { bgPos += 'center'; } else { this.style.left = Math.max(0, (document.body.clientWidth - (r ? this.height : this.width)) / 2 - borderSize) + 'px'; }
						}

						if (bgM) { this.parentNode.style.backgroundPosition = bgPos; }
					}
				};

				img.calcFit = function () {
					noFit = {
						cur: (this.width <= window.innerWidth && this.height <= window.innerHeight),
						real: (this.naturalWidth <= window.innerWidth && this.naturalHeight <= window.innerHeight)
					};
				};

				img.zoom = function (e) {
					e.preventDefault();

					var point = e.target.nodeName === 'IMG';

					if (point) {
						var w = img.width, h = img.height;
					}

					if (e.wheelDelta > 0) {
						if (img.height >= MAXSIZE || img.height >= MAXSIZE) { return; }

						var width = img.width * (e.altKey || e.accelerate ? 1.4 : 1.2);
						img.resize(-1, Math.min(MAXSIZE, width > 10 ? width : width + 2 ));
					}
					else {
						img.resize(-1, Math.max(1, img.width * (e.altKey || e.accelerate ? 0.6 : 0.8)));
					}

					if (point && w !== img.width) {
						window.scrollTo(e.offsetX * img.width / w - e.clientX, e.offsetY * img.height / h - e.clientY);
					}
				};

				if (cfg.scrollzoom === '0') {
					var onwheel = function (e) {
						window.scrollBy(-e.wheelDelta, 0);
						e.preventDefault();
					};

					img.hScroll = function (force) {
						var hS;

						switch (prefs.dam) {
							case -1:
							case 0: hS = (window.innerWidth < this.width && parseInt(cfg.hlonger, 10) && this.height < (this.width / parseInt(cfg.hlonger, 10)) ? true : false); break;
							case 3: hS = (window.innerWidth < this.width ? true : false); break;
							default: hS = false;
						}

						if (force) {
							hS = !hS;

							window.onkeyup = function(e) {
								if (e.keyCode === 88) {
									img.hScroll();
									window.onkeyup = null;
								}
							};
						}

						if (hS) { window.addEventListener('mousewheel', onwheel, false); }
						else { window.removeEventListener('mousewheel', onwheel, false); }
					};
				}
				else {
					img.hScroll = function () {};

					window.addEventListener('mousewheel', img.zoom, false);
				}

				if (cfg.cursor === '1') {
					img.cursor = function () {
						if (this.width > window.innerWidth || this.height > window.innerHeight) {
							this.style.cursor = 'move';
						}
						else if (((window.innerHeight >= this.height && window.innerWidth >= this.width) && (window.innerHeight < this.naturalHeight || window.innerWidth < this.naturalWidth)) ||
						(noFit.cur && noFit.real && (this.height < this.naturalHeight || this.width < this.naturalWidth))) {
							this.style.cursor = 'zoom-in';
						}
						else { this.style.cursor = 'default'; }
					};
				}
				else {
					img.cursor = function () {};
				}

				if ((prefs.dam === 2 && img.naturalWidth < window.innerWidth) || (prefs.dam === 3 && img.naturalHeight < window.innerHeight)) {
					prefs.dam = 0;
				}

				img.resize(prefs.dam);

				window.addEventListener('resize', function () {
					img.position(prefs.pos);
					img.calcFit();
					img.hScroll();
					img.cursor();
					setStatus();
				}, false);

				if (!window.O_EX_CM) { window.O_EX_CM = {}; }
				window.O_EX_CM.Imagus = {title:true, menudata: [
					[LNG.ORIGINAL_SIZE, function() { img.resize(0); }, String.fromCharCode(keys.modeAuto)],
					[LNG.BEST_FIT, function() { img.resize(1); }, String.fromCharCode(keys.modeFit)],
					[LNG.FIT_TO_WIDTH, function() { img.resize(2); }, String.fromCharCode(keys.modeFitW)],
					[LNG.FIT_TO_HEIGHT, function() { img.resize(3); }, String.fromCharCode(keys.modeFitH)],
					[LNG.MORE, [
						[LNG.TO_BACKGROUND, function() { img.resize(4); }, String.fromCharCode(keys.modeBg)],
						[LNG.CUSTOM_SIZE, function() { img.setSize(); }, String.fromCharCode(keys.customSize)],
						[LNG.RESET_IMAGE, function() { img.reset(); }, 'Esc']
					], '»'],
					[],
					[LNG.TRANSFORM, [
						[LNG.FLIP_H, function() { img.flip(1); }, String.fromCharCode(keys.flipH)],
						[LNG.FLIP_V, function() { img.flip(0); }, String.fromCharCode(keys.flipV)],
						[],
						[LNG.ROT_LEFT, function() { img.rotate(0); }, String.fromCharCode(keys.rotateLeft)],
						[LNG.ROT_RIGHT, function() { img.rotate(1); }, String.fromCharCode(keys.rotateRight)]
					], '»'],
					[LNG.PREFERENCES, function() { oex.postMessage({cmd:'open', url:'options.html'}); }, String.fromCharCode(keys.prefs)]
				]};

				var cxmenu, generateMenu, contextmenu = function (mx, my) {
					createHelper();

					if (cxmenu) {
						cxmenu.style.left = mx + 'px';
						cxmenu.style.top = my + 'px';
						hLayer.style.border = 0;
						hLayer.style.left = 0;
						hLayer.style.top = 0;
						hLayer.style.width = '100%';
						hLayer.style.height = '100%';
						hLayer.style.display = 'block';
						return;
					}
					else {
						/*-o-transition:opacity 300ms;opacity:0;*/
						document.head.firstChild.textContent += '#O_EX_CM{display:none;position:fixed;text-shadow:none;z-index:666}#O_EX_CM,#O_EX_CM ul{background-color:#f0f0f0;border:1px solid #a0a0a0;box-shadow:2px 2px 2px #8e8e8e;display:inline-block;list-style:none;margin:0;padding:2px}#O_EX_CM li{position:relative}#O_EX_CM li ul{display:none;left:100%;position:absolute;top:-5px}#O_EX_CM li:hover ul{display:block}#O_EX_CM li a+i{color:grey;font-style:normal;position:absolute;right:5px;text-shadow:0 0 1px #fff;top:2px}#O_EX_CM .title{color:silver;letter-spacing:1px;padding:10px 5px 6px;text-shadow:0 0 0 #000}#O_EX_CM li:empty{border-bottom:1px solid #fff;border-top:1px solid #a0a0a0;margin:5px 7px 4px}#O_EX_CM .title:first-child{padding-top:0}#O_EX_CM a{border:1px solid transparent;color:#000;cursor:default;display:block;padding:2px 40px 2px 10px;text-decoration:none;white-space:nowrap}#O_EX_CM a:hover{background-color:#46a9ff;border:1px solid #1676ff;color:#fff}';
						cxmenu = document.createElement('UL');
						cxmenu.id = 'O_EX_CM';

						hLayer.appendChild(cxmenu);
						hLayer.addEventListener('mouseup', hLayer.hide, false);

						generateMenu = function (ext_menu_data) {
							var tmpel, mfragment = document.createDocumentFragment(), a, key, i, l;

							for (i = 0, l = ext_menu_data.length; i < l; ++i) {
								if (!ext_menu_data[i].length) {
									mfragment.appendChild(document.createElement('LI'));
								}
								else if (ext_menu_data[i][1] instanceof Array) {
									tmpel = document.createElement('LI');
									a = document.createElement('A'); ul = document.createElement('UL');
									a.innerText = ext_menu_data[i][0];
									tmpel.appendChild(a);

									if (ext_menu_data[i][2]) {
										key = document.createElement('I');
										key.textContent = ext_menu_data[i][2];
										tmpel.appendChild(key);
									}

									ul.appendChild(generateMenu(ext_menu_data[i][1]));
									tmpel.appendChild(ul);
									mfragment.appendChild(tmpel);
								}
								else {
									tmpel = document.createElement('LI');
									a = document.createElement('A');
									a.innerText = ext_menu_data[i][0];

									if (ext_menu_data[i][1]) { a.onclick = ext_menu_data[i][1]; }
									tmpel.appendChild(a);

									if (ext_menu_data[i][2]) {
										key = document.createElement('I');
										key.textContent = ext_menu_data[i][2];
										tmpel.appendChild(key);
									}

									mfragment.appendChild(tmpel);
								}
							}

							return mfragment;
						};
					}

					var tmpel, mfragment = document.createDocumentFragment(), ext;

					for (ext in window.O_EX_CM) {
						if (window.O_EX_CM[ext].title) {
							tmpel = document.createElement('LI');
							tmpel.className = 'title';
							tmpel.textContent = ext;
							mfragment.appendChild(tmpel);
						}

						mfragment.appendChild(generateMenu(window.O_EX_CM[ext].menudata));
					}

					cxmenu.style.cssText = 'left:'+mx+'px;top:'+my+'px;display:block';
					cxmenu.appendChild(mfragment);

					hLayer.style.border = 0;
					hLayer.style.left = 0;
					hLayer.style.top = 0;
					hLayer.style.width = '100%';
					hLayer.style.height = '100%';
					hLayer.style.display = 'block';
				};

				window.addEventListener('contextmenu', function(e) {
					window.onmousemove = null;
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction === 2) { cancelAction = false; e.preventDefault(); }
				}, false);

				var onmove = function (e) {
					if (fZoom) {
						if (fZoom.stage === 0) {
							if (!e.shiftKey) {
								fZoom = null;
								return;
							}

							createHelper();
							hLayer.innerHTML = '';
							cxmenu = null;

							var rot = img.currentdeg && Math.sin(img.currentdeg) ? true : false,
								w = rot ? img.height : img.width,
								h = rot ? img.width : img.height;
							if (w > window.innerWidth) {
								hLayer.style.left = parseInt(borderSize, 10);
								hLayer.style.width = window.innerWidth + 'px';
							}
							else {
								hLayer.style.left = (img.offsetLeft + borderSize) + 'px';
								hLayer.style.width = w + 'px';
							}

							if (h > window.innerHeight) {
								hLayer.style.top = parseInt(borderSize, 10);
								hLayer.style.height = window.innerHeight + 'px';
							}
							else {
								hLayer.style.top = (img.offsetTop + borderSize) + 'px';
								hLayer.style.height = h + 'px';
							}

							// helper width, height
							fZoom.hW = parseInt(hLayer.style.width, 10);
							fZoom.hH = parseInt(hLayer.style.height, 10);

							// helper top, left
							fZoom.hT = parseInt(hLayer.style.top, 10);
							fZoom.hL = parseInt(hLayer.style.left, 10);

							// helper right, bottom
							fZoom.hR = fZoom.hL + fZoom.hW;
							fZoom.hB = fZoom.hT + fZoom.hH;

							fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
							fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
							fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
							fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);

							hLayer.style.borderStyle = 'solid';
							hLayer.style.borderColor = 'rgba(0,0,0,.5)';
							hLayer.style.borderWidth = fZoom.t + 'px ' + fZoom.r + 'px ' + fZoom.b + 'px ' + fZoom.l + 'px';
							hLayer.style.display = 'block';

							++fZoom.stage;
						}
						else {
							if (e.ctrlKey) {
								if (fZoom.sX) {
									var x = fZoom.sX - e.screenX, y = fZoom.sY - e.screenY;

									if (y !== 0) {
										hLayer.style.borderBottomWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderBottomWidth, 10) + y), fZoom.hH) + 'px';
										hLayer.style.borderTopWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderTopWidth, 10) - y), fZoom.hH) + 'px';
									}

									if (x !== 0) {
										hLayer.style.borderRightWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderRightWidth, 10) + x), fZoom.hW) + 'px';
										hLayer.style.borderLeftWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderLeftWidth, 10) - x), fZoom.hW) + 'px';
									}
								}

								fZoom.sX = e.screenX;
								fZoom.sY = e.screenY;

								return;
							}

							if (fZoom.sX) {
								fZoom.sX = null;
								fZoom.sY = null;
								if (fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10) < e.clientX) { fZoom.cX = fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10); }
								else { fZoom.cX = fZoom.hL + fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10); }

								if (fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10) < e.clientY) { fZoom.cY = fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10); }
								else { fZoom.cY = fZoom.hT + fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10); }

								//borders
								fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
								fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
								fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
								fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);
							}

							var t, r, b, l;

							if (fZoom.cY < e.clientY) {
								b = Math.max(0, fZoom.hB - e.clientY);
								t = fZoom.t;
							}
							else {
								b = fZoom.b;
								t = Math.max(0, e.clientY - fZoom.hT);
							}

							if (fZoom.cX < e.clientX) {
								r = Math.max(0, fZoom.hR - e.clientX);
								l = fZoom.l;
							}
							else {
								r = fZoom.r;
								l = Math.max(0, e.clientX - fZoom.hL);
							}

							hLayer.style.borderWidth = t + 'px ' + r + 'px ' + b + 'px ' + l + 'px';
						}

						return;
					}

					if (progress) { clearTimeout(progress); progress = null;}

					if (sX === true || prefs.pixelmove < 1 || noFit.cur || !parseInt(prefs.pixelmove, 10)) { window.onmousemove = null; return;}

					if (!--pixelThresHold) {
						window.scrollBy(sX - e.screenX, sY - e.screenY);

						sX = e.screenX;
						sY = e.screenY;
						pixelThresHold = prefs.pixelmove;
					}

					if (dragScroll.length !== 3) {
						dragScroll = [ [e.screenX, e.screenY], [e.screenX, e.screenY], [e.screenX, e.screenY] ];
						return;
					}

					dragScroll[0] = [dragScroll[1][0], dragScroll[1][1]];
					dragScroll[1] = [dragScroll[2][0], dragScroll[2][1]];
					dragScroll[2] = [e.screenX, e.screenY];

					img.dragScrollTime = Date.now();
				};

				if (prefs.dragScroll !== 0) {
					var stopScroll = function (e, c_action) {
						if (dragScroll.length) {
							clearInterval(progress);
							progress = null;
							cancelAction = c_action ? true : false;
							dragScroll = [];
							img.dragScrollTime = false;
						}

						if (e) {
							window.removeEventListener('mousewheel', stopScroll, false);
						}
					};

					var scroll = function () {
						window.scrollBy(dragScroll[0], dragScroll[1]);

						if (dragScroll[0]) {
							if (Math.abs(dragScroll[0]) < 1) {
								dragScroll[0] = 0;
							}

							dragScroll[0] /= prefs.dragScroll;
						}

						if (dragScroll[1]) {
							if (Math.abs(dragScroll[1]) < 1) {
								dragScroll[1] = 0;
							}

							dragScroll[1] /= prefs.dragScroll;
						}

						var atRight = document.documentElement.scrollWidth - window.scrollX === document.documentElement.clientWidth,
							atBottom = document.documentElement.scrollHeight - window.scrollY === document.documentElement.clientHeight;

						if (!(dragScroll[0] && dragScroll[1]) || (!window.scrollY && !window.scrollX) || (!window.scrollY && atRight) || (atBottom && !window.scrollX) || (atBottom && atRight)) {
							stopScroll();
						}
					};
				}

				img.onmousedown = function(e) {
					if (e.button === 1 || e.ctrlKey || e.altKey) { return; }

					if ((e.button === 0 && prefs.dam < 4) || e.button === 2) {
						if (prefs.pixelmove === 0) {
							window.onmousemove = function () {if (progress) { clearTimeout(progress); progress = null; } window.onmousemove = null; };
						}
						else {
							window.onmousemove = onmove;
						}

						if (e.button === 2) {
							sX = true;
						}
						else {
							e.preventDefault();
							sX = e.screenX;
							sY = e.screenY;
						}
					}

					if (!prefs.mDownDelay) {
						return;
					}

					if (e.shiftKey || fZoom === 0) {
						cancelAction = true;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;
							contextmenu(e.clientX, e.clientY);
						}
						else {
							fZoom = {stage:0, cX: e.clientX, cY: e.clientY};

							if (window.onmousemove === null) {
								window.onmousemove = onmove;
							}
						}
					}

					if (progress) {
						stopScroll && stopScroll(false, true);

						if (e.button === 0) {
							return;
						}
					}

					if (e.shiftKey) { return; }

					progress = setTimeout(function () {
						cancelAction = true;
						progress = null;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;

							try { if (img.src !== window.top.location.href) { oex.postMessage({cmd:'open', url: img.src, nf: e.shiftKey}); return; } } catch (ex) {}

							contextmenu(e.clientX, e.clientY);
							return;
						}

						var x, y, tmpsize;

						if (prefs.dam === 2 || img.width === window.innerWidth) {
							tmpsize = img.width;

							img.resize(3);

							x = e.offsetX * img.width / tmpsize - window.innerWidth / 2;
							y = 0;
						}
						else {
							tmpsize = img.height;

							img.resize(2);

							x = 0;
							y = e.offsetY * img.height / tmpsize - window.innerHeight / 2;
						}

						window.scrollTo(x, y);
					}, prefs.mDownDelay);
				};

				window.onmouseup = function(e) {
					if (e.button !== 0) { return; }

					if (prefs.dam < 4) {
						window.onmousemove = null;
						//d('removed');

						if (fZoom) {
							hLayer.style.display = 'none';
							var nimgw, nimgh,
							w = fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10),
							h = fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10),
							scrollbars = prefs.hideSB ? 0 : 17,
							winW = window.innerWidth - scrollbars,
							winH = window.innerHeight - scrollbars;

							var fitW = winW < w * winH / h;

							fitW = e.ctrlKey ? !fitW : fitW;

							if (fitW) {
								nimgw = img.width * winW / w;
								nimgh = nimgw * img.height / img.width;
							}
							else {
								nimgh = img.height * winH / h;
								nimgw = nimgh * img.width / img.height;
							}

							if (nimgw > MAXSIZE) {
								nimgw = MAXSIZE;
								nimgh = img.height * MAXSIZE / img.width;
							}

							if (nimgh > MAXSIZE) {
								nimgw = img.width * MAXSIZE / img.height;
								nimgh = MAXSIZE;
							}

							var cx = (window.scrollX + parseInt(hLayer.style.borderLeftWidth, 10) + w / 2) * nimgw / img.width - window.innerWidth / 2 - scrollbars;
							var cy = (window.scrollY + parseInt(hLayer.style.borderTopWidth, 10) + h / 2) * nimgh / img.height - window.innerHeight / 2 - scrollbars;

							img.resize(-1, nimgw, nimgh);

							window.scrollTo(cx, cy);

							fZoom = null;
							cancelAction = false;
							hLayer.textContent = '';
						}
						else if (dragScroll.length === 3) {
							var x = dragScroll[0][0] - dragScroll[2][0], y = dragScroll[0][1] - dragScroll[2][1];

							if ((Date.now() - img.dragScrollTime) > 100) { return; }

							//x = x < 0 ? Math.max(-1000, x) : Math.min(1000, x);
							//y = y < 0 ? Math.max(-1000, y) : Math.min(1000, y);

							dragScroll = [x, y];
							progress = setInterval(scroll, 0xF);
							window.addEventListener('mousewheel', stopScroll, false);
						}
					}
				};

				img.onclick = function(e) {
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction) { cancelAction = false; return; }

					if (e.button !== 0) { return; }

					if (prefs.dam < 2 && noFit.real) {
						if (prefs.dam === -1) { this.resize(0); }
						else if (window.innerWidth < this.naturalWidth * window.innerHeight / this.naturalHeight) { this.resize(2); }
						else { this.resize(3); }

						return;
					}

					if (prefs.dam === 1 || noFit.cur) {
						if (this.naturalWidth === this.width && this.naturalHeight === this.height) {return;}

						var x, y;

						x = e.offsetX;
						y = e.offsetY;

						if (this.scale) {
							if (this.scale.h === -1) {
								x = this.width - e.offsetX;
							}

							if (this.scale.v === -1) {
								y = this.height - e.offsetY;
							}
						}

						x = x * this.naturalWidth / this.width - window.innerWidth / 2;
						y = y * this.naturalHeight / this.height - window.innerHeight / 2;

						this.resize(0);

						window.scrollTo(x, y);
					}
					else { this.resize(1); }
				};

				window.onkeypress = function(e) {
					if (e.keyCode === 43 || e.keyCode === 45) {
						e.accelerate = e.ctrlKey;

						if (e.keyCode === 43) {
							e.wheelDelta = 1;
						}
						else {
							e.wheelDelta = -1;
						}

						img.zoom(e);
					}
				};

				window.onkeydown = function(e) {
					stopScroll();

					if ((fZoom && e.keyCode !== keys.reset) || /(?:TEXTAREA|INPUT|SELECT)/.test(e.target.nodeName)) { return; }

					if (e.ctrlKey) {
						if (e.shiftKey && ' 37 38 39 40 '.indexOf(' ' + e.keyCode + ' ') !== -1) {
							var newpos,
							x = prefs.pos.charAt(0),
							y = prefs.pos.charAt(1);

							switch (e.keyCode) {
								case 37: --x; break;
								case 39: ++x; break;
								case 38: --y; break;
								case 40: ++y;
							}

							x < 0 ? x = '0' : x > 2 && (x = '2');
							y < 0 ? y = '0' : y > 2 && (y = '2');

							newpos = x + y;

							if (newpos !== prefs.pos) {
								img.position(newpos);
								prefs.pos = newpos;
							}
						}

						return;
					}

					switch (e.keyCode) {
						// sizemode shortcuts 1-5
						case keys.modeAuto: case keys.modeFit: case keys.modeFitW: case keys.modeFitH: case keys.modeBg: img.resize(e.keyCode - 49); break;

						case keys.customSize: img.setSize(); break;

						case keys.reset : img.reset(); break;

						case keys.prefs : oex.postMessage({cmd:'open', url:'options.html'}); break;

						case keys.rotateLeft : img.rotate(0); break;
						case keys.rotateRight : img.rotate(1); break;

						case keys.flipH : img.flip(0); break;
						case keys.flipV : img.flip(1); break;

						case keys.cycle : img.cycle(); break;

						case keys.contextMenu : contextmenu(window.innerWidth / 2 - 100, window.innerHeight / 2 - 100); break;

						case 88 : img.hScroll(true);
					}
				};

				img.cycle = function () {
					var n_s = prefs.dam + 1;

					if (n_s > 3) { n_s = 0; }

					this.resize(n_s);
				};

				img.reset = function () {
					if (document.readyState !== 'complete') { return; }

					if (hLayer) {
						fZoom = null;
						cancelAction = false;

						if (hLayer.style.display === 'block') {
							hLayer.innerHTML = '';
							hLayer.style.display = 'none';
							return;
						}

						document.body.removeChild(hLayer);
						hLayer = null;
					}

					delete this.currentdeg;
					delete this.scale;
					this.style.OTransform = this.style.width = this.style.height = this.parentNode.style.backgroundSize = '';
					this.resize(0);
				};

				img.setSize = function () {
					setTimeout(function() {
						var size = prompt('(0 < x,y < '+MAXSIZE+')\n' + LNG.ORIG_DIMENS + ': ' + img.naturalWidth + ' x ' + img.naturalHeight, '0');

						if (!size) { return; }

						size = size.replace(/(^\s*|\s*$)/g, '');

						if (/^(\d{1,5}%?)(\s+\d{1,5}%?)?$/i.test(size)) {
							size = size.split(/\s+/);

							if (prefs.dam === 4) {
								if (size[0] == 0) { size[0] = 'auto'; }
								if (size[1] && size[1] == 0) { size[1] = 'auto'; }
								document.body.style.backgroundSize = size.join(' ');
							}
							else {
								var w = '', h = '';

								if (parseInt(size[0], 10) > 0) {
									w = size[0].indexOf('%') > 0 ? size[0] : Math.min(Math.max(0, size[0]), MAXSIZE);
								}

								if (size[1] && parseInt(size[1], 10) > 0) {
									h = size[1].indexOf('%') > 0 ? size[1] : Math.min(Math.max(0, size[1]), MAXSIZE);
								}

								img.resize(-1, w, h);
							}
						}
						else { alert(LNG.INCORRECT_VALUE + '!'); }
					}, 1);
				};

				img.rotate = function (lr) {
					var rot = this.style.OTransform.match(/rotate\(([\-\.\d]+)deg\)/i);

					if (!rot) { this.currentdeg = 0; }

					if (lr) { this.currentdeg += 90; }
					else { this.currentdeg -= 90; }

					if (this.currentdeg !== 0 && Math.cos(this.currentdeg * 0.017453292519943295) === 1) { this.currentdeg = 0; }

					window.status = this.currentdeg;

					if (typeof this.currentdeg !== 'undefined') { rot = 'rotate('+ this.currentdeg +'deg)'; }
					if (this.scale) { rot+=' scale('+this.scale.h+','+this.scale.v+')'; }
					this.style.OTransform = rot;
				};

				img.flip = function (ori) {
					if (!this.scale) { this.scale= {h: 1, v: 1 }; }

					if (ori) { this.scale.h = -this.scale.h; }
					else { this.scale.v = -this.scale.v; }

					var flip = (!this.scale.h && !this.scale.v) ? '' : 'scale('+this.scale.h+','+this.scale.v+')';
					if (this.currentdeg) { flip='rotate('+this.currentdeg+'deg) ' + flip; }
					this.style.OTransform = flip;
				};
			}
			else if (++init.loop >= init.maxloop) {
				clearInterval(progress);
			}
		}

		if (img.naturalWidth && img.naturalHeight) { load(true); }
		else { progress = setInterval(load, init.wait);}

		oex.onmessage = null;
	};

	window.onkeypress = window.onmousedown = window.onmouseup = null;
}
else {
	var mdownstart,
			rgxBgURL = /"([^"]+)"/gi,
			rgxProtCheck = /^\w+:/i,
			rgxRemHash = /[\?#].*$/,
			rgxDomain = /^(\w+:\/\/[^\/]+)\/.*$/,
			rgxPath = /(\/)[^\/]*$/,
			rgxObjImg = /(?:jp(?:e|e?g)|a?png|gif|w?bmp|svg|webp|ico|xbm|j(?:if|fif?))$/i,

	checkBG = function (match/*, p*/) {
		if (match) {
			var el_images = [], imaddr, i;

			for (i in match) {
				imaddr = match[i].slice(1, -1);

				if (!rgxProtCheck.test(imaddr)) {
					imaddr = document.baseURI.replace(rgxRemHash, '').replace((imaddr.charAt(0) === '/' ? rgxDomain : rgxPath), '$1') + imaddr;
				}

				el_images.push(imaddr);
			}

			//return p && el_images.length > 0 ? {path: p, imgs: el_images} : el_images;
			return el_images.length > 0 ? el_images : null;
		}

		return null;
	},

	checkIMG = function (node) {
		if (!node) { return null; }

		if (node.nodeName === 'IMG' || (node.type === 'image' && /^(?:BUTTON|INPUT)/.test(node.nodeName))) {
			return node.src;
		}
		// http://www.opera.com/docs/specs/presto211/#graphics
		else if (node.nodeName === 'OBJECT' && (/^image/i.test(node.type) || rgxObjImg.test(node.data))) {
			return node.data;
		}
		else if (node.nodeName === 'AREA') {
			var usemapImg = document.querySelector('img[usemap="#' + node.parentNode.name + '"]');

			if (usemapImg) {
				return usemapImg.src;
			}
		}
		else if (node.nodeName === 'VIDEO') {
			return node.poster;
		}
		else {
			return null;
		}
	};

	window.opera.addEventListener('BeforeEvent.mousedown', function (e) {
		if (e.event.button === 2) { mdownstart = Date.now(); }
	}, false);

	window.opera.addEventListener('BeforeEvent.contextmenu', function (ev) {
		var e = ev.event, img, el, i, bgImages = [];

		if (e.button !== 2) { return; }
		var elapsed = (Date.now() - mdownstart) >= 300;
		mdownstart = 0;

		if (e.ctrlKey && e.altKey && elapsed) {
			ev.preventDefault();
			e.preventDefault();
			oex.postMessage({cmd:'favi', nf: e.shiftKey});
			return;
		}

		if (e.ctrlKey && elapsed) {
			el = e.target;
			i = 10;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (i === 9) {
					el = el.previousElementSibling || el.parentNode;
				}
				else {
					if (el.childElementCount) {
						el = el.lastElementChild;
					}
					else if (el.previousElementSibling) {
						el = el.previousElementSibling;
					}
					else if (el.parentNode) {
						el = el.parentNode.previousElementSibling;
					}
					else {
						el = false;
					}
				}
			}

			// need check
			el = e.target.childElementCount ? e.target.firstElementChild : (e.target.nextElementSibling || e.target.parentNode.nextElementSibling);
			i = 10;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (el.childElementCount) {
					el = el.firstElementChild;
				}
				else if (el.nextElementSibling) {
					el = el.nextElementSibling;
				}
				// while el.parentNode.nextElementSibling or not
				else if (el.parentNode && el.parentNode.nextElementSibling) {
					el = el.parentNode.nextElementSibling;
				}
				else {
					el = false;
				}
			}
		}

		if ((e.altKey || elapsed) && !(e.altKey && elapsed)) {
			if (e.target.document instanceof window.SVGDocument) {
				if (e.target.document.URL !== window.top.location.href) {
					bgImages.push(e.target.document.URL);
				}
			}
			else {
				img = checkIMG(e.target);
				img && bgImages.push(img);
			}
		}

		if ((e.ctrlKey || elapsed) && !(e.ctrlKey && elapsed) && !(e.target.document instanceof window.SVGDocument)) {
			el = e.target;

			if (el.nodeName === 'HTML') {
				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL) || document.body.currentStyle.backgroundImage.match(rgxBgURL), 'html>body');
				img && (bgImages = bgImages.concat(img));
			}
			else {
				var imgList;//, path = '';

				while(el && el.nodeName !== '#document') {
					//path = path ? el.nodeName + '>' + path : el.nodeName;
					match = el.currentStyle.backgroundImage.match(rgxBgURL);

					if (el.nodeName === 'UL') {
						var f = el.currentStyle.listStyleImage.match(rgxBgURL);
						if (f) {
							if (match) { match.push(f); }
							else { match = f; }
						}
					}

					imgList = checkBG(match/*, path*/);
					imgList && (bgImages = bgImages.concat(imgList));

					el = el.parentNode;
				}
			}
		}

		if (bgImages && bgImages.length > 0) {
			ev.preventDefault();
			e.preventDefault();

			if (!(e.ctrlKey && e.altKey) && !(e.ctrlKey && elapsed)) {
				oex.postMessage({cmd:'open', url: bgImages[0], nf: e.shiftKey});
			}
			else {
				if (bgImages.length > 1) {
					var a = [], l = bgImages.length, j;

					for (i = 0; i < l; ++i) {
						for (j = i + 1; j < l; ++j) {
							if (bgImages[i] === bgImages[j]) {
								j = ++i;
							}
						}

						a.push(bgImages[i]);
					}

					bgImages = a;
				}

				for (i = 0; i < bgImages.length; ++i) {
					oex.postMessage({cmd:'open', url: bgImages[i], nf: e.shiftKey});
				}
			}
		}
	}, false);
}
})();